package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10053LoginNewWineResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10053SendBeanNewWine;
import cn.net.cpzslibs.prot.utils.StrUtils;

/*
 * 新酒登录
 */
public class Prot10053NewWineLogin extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10053 = 10053;
	
	private Gson gson;
	
	private Prot10053LoginNewWineResult loginResult;
	
	public Prot10053NewWineLogin() {
		gson = new Gson();
	}
	
	
	
	
	public Prot10053LoginNewWineResult getLoginResult() {
		return loginResult;
	}




	public void setLoginResult(Prot10053LoginNewWineResult loginResult) {
		this.loginResult = loginResult;
	}




	public void dealCpzsNewWine(SocketCreate create, Prot10053SendBeanNewWine loginBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), loginBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10053SendBeanNewWine loginBean)
			throws IOException {
		if (socket.isConnected()) {
			
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10053, "开始发送登录信息");
				sendProt(dos, loginBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	
	
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10053, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10053, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			loginResult = gson.fromJson(jsonData, Prot10053LoginNewWineResult.class);
		}
		recCheckCode(dis);
	}
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10053SendBeanNewWine loginBean) throws IOException {
		String bodyContent = gson.toJson(loginBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10053, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	
}
